<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: chart/series/LineSeries.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: chart/series/LineSeries.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'd3', 'ss', 'uweaver/lang', 'uweaver/widget/Widget',
    'uweaver/data/Collection', 'uweaver/dom', 'uweaver/string'], function(_, $, d3, ss, lang, Widget, Collection, dom, string) {

    var declare = lang.declare;
    var Base = Widget;

    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            mode: 'linear',
            marker: {
                type: 'circle',
                r: 4,
                fill: 'white',
                'stroke-width': '2px'
            },
            style: {
                'fill': 'none',
                stroke: 'black'
            },
            tooltips: {}
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._component = d3.select(this.el);
        this._scales = {};

        this.marker(cfg.marker);
        this.css(cfg.style);
        this.title(cfg.title);
        this.mode(cfg.mode);
        cfg.xField &amp;&amp; (this._xField = cfg.xField);
        cfg.yField &amp;&amp; (this._yField = cfg.yField);
        cfg.xAxis &amp;&amp; (this._xAxis = cfg.xAxis) ;
        cfg.yAxis &amp;&amp; (this._yAxis = cfg.yAxis) ;
        (cfg.data) ? this.data(cfg.data, {render: false}) : this.data(new Collection(), {render: false});
    }

    function render(options) {
        var defaults = {
            hidden: false
        };

        options || (options = {});
        _.defaults(options, defaults);

        var dataset = this._dataset;
        var marker = this.marker();
        var xField = this._xField, yField = this._yField;
        var xAxis = this._xAxis, yAxis = this._yAxis;
        var anchors = this._anchors;

        this._component.selectAll('g').remove();

        var line = d3.svg.line()
            .x(function(item) {
                var value = item[xField] ? item[xField]() : item.get(xField);
                value || (value = 0);
                var x = xAxis.scale().project(value);
                return x;
            })
            .y(function(item) {
                var value = item[yField] ? item[yField]() : item.get(yField);
                value || (value = 0);
                var y = yAxis.scale().project(value);
                return y;
            }).interpolate(this.mode());

        this._component.append('g').append('path').attr('d', line(dataset)).attr({
            fill: 'none',
            'stroke-width': '2px'
        });

        this._component.append('g').selectAll(marker.type)
            .data(dataset).enter().append(marker.type).attr(marker)
            .attr('cx', function(item){
                var value = item[xField] ? item[xField]() : item.get(xField);
                value || (value = 0);
                var cx = xAxis.scale().project(value);
                return cx;
            }).attr('cy', function(item) {
                var value = item[yField] ? item[yField]() : item.get(yField);
                value || (value = 0);
                var cy = yAxis.scale().project(value);
                return cy;
            }).attr('cid', function(item) {return item.cid});

        if(this.cfg().tooltips.display!=='none') {
            this.$('g > circle').on('mouseenter', _.bind(onMarkerHoverIn, this));
            this.$('g > circle').on('mouseleave', _.bind(onMarkerHoverOut, this));
        }


        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }
        return this;
    }

    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof CartesianChart#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the chart from being rendered.
     * @returns {CartesianChart} this
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        var xField = this._xField, yField = this._yField;
        this._dataset = items.filter(function(item) {
            return (item.has(xField) &amp;&amp; item.has(yField));
        });
        this.listenTo(this._data, "update", _.bind(onItemsUpdate, this));

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this;
    }

    function onItemsUpdate() {
        this.refresh();
    }

    function refresh() {

    }

    function title(text) {
        if(!text) return this._title;

        this._title = text;
    }

    function marker(marker) {
        if(!marker) return this._marker;

        this._marker = marker;
    }

    function xField() {
        return this._xField;
    }

    function yField() {
        return this._yField;
    }

    function xAxis() {
        return this._xAxis;
    }

    function yAxis() {
        return this._yAxis;
    }

    function mode(mode) {
        if(!mode) return this._mode;
        this._mode = mode;
    }

    function trendline() {
        var xField = this.xField(), yField = this.yField();
        var xAxis = this.xAxis(), yAxis = this.yAxis();
        var dataset = this._dataset;
        var data = _.map(dataset, function(item) {
            var xValue = item[xField] ? item[xField]() : item.get(xField);
            xValue || (xValue = 0);
            var yValue = item[yField] ? item[yField]() : item.get(yField);
            yValue || (yValue = 0);

            return [xAxis.project(xValue), yAxis.project(yValue)];
        });
        var lr = ss.linearRegressionLine(ss.linearRegression(data));

        var trend = d3.svg.line()
            .x(function(item) {
                var value = item[xField] ? item[xField]() : item.get(xField);
                value || (value = 0);
                return xAxis.project(value);
            })
            .y(function(item) {
                var value = item[xField] ? item[xField]() : item.get(xField);
                value || (value = 0);
                return lr(xAxis.project(value));
            });

        var stroke = d3.lab(this.css('stroke')).brighter(1);
        this._component.append('path').attr('d', trend(dataset)).attr({
            fill: 'none',
            'stroke-width': '2px',
            'stroke-dasharray': '3, 3',
            stroke: stroke
        });
    }

    function onMarkerHoverIn(event) {
        var marker = event.currentTarget;
        var $marker = $(marker);
        var cid = $marker.attr('cid');
        var rect = marker.getBBox();
        var x = rect.x + rect.width / 2;
        var y = rect.y + rect.height / 2;
        var cfg = this.cfg();
        var item = this.data().get(cid);

        var text = (cfg.tooltips.renderer) ? cfg.tooltips.renderer(item) : tooltipsRenderer.call(this, item);

        showTooltips.call(this, text, {x: x, y: y});
    }

    function tooltipsRenderer(item) {
        var xField = this._xField, yField = this._yField;
        var xAxis = this._xAxis, yAxis = this._yAxis;
        var title = this._title;
        var tpl = "${title} ${preposition} ${xValue} is ${yValue}";
        var preposition = "of";
        
        if(xAxis.type()==='TIME') {
            if(xAxis.ticks()==='HOURS'||xAxis.ticks()==='MINUTES') {
                preposition = "at";
            } else if(xAxis.ticks()==='DAYS') {
                preposition = "on";
            } else {
                preposition = "in";
            }
        }

        return string.substitute(tpl, {
            title: title,
            xValue: xAxis.format(item.get(xField)),
            yValue: yAxis.format(item.get(yField)),
            preposition: preposition
        });
    }

    function onMarkerHoverOut(event) {
        hideTooltips.call(this);
    }

    function showTooltips(text, options) {
        var tooltips = getTooltips.call(this);
        var PADDING = 10;

        var textNode = tooltips.select('text').text(text);
        var textSize = dom.sizing(textNode);
        var calloutSize = {
            height: textSize.height + PADDING * 2,
            width: textSize.width + PADDING * 4
        };
        tooltips.select('path').attr('d', callout(calloutSize));
        textNode.attr({
            x: calloutSize.width / 2,
            y: calloutSize.height / 2 + textSize.height / 2 * 0.8
        });

        var x = options.x + 10;
        var y = options.y - calloutSize.height / 2;
        tooltips.attr('transform', 'translate(' + x + ', ' + y + ')')
            .style({display: ''});
    }

    function getTooltips() {
        var anchors = this._anchors;

        if(anchors.tooltips) return anchors.tooltips;

        anchors.tooltips = this._component.append('g').style({
            'display': 'none'
        });

        anchors.tooltips.append('path').style({
            fill: 'white',
            'stroke-width': 2,
            'opacity': 0.8
        });
        anchors.tooltips.append('text').style({
            stroke: 'none',
            'text-anchor': 'middle'
        });

        return anchors.tooltips;
    }

    function callout(size) {
        var triangleWidth = size.height * 0.4, triangleHeight = triangleWidth * 10 / 16;
        var de = (size.height - triangleWidth) / 2, ga = de;
        var path = "M${triangleHeight} 0 L${width} 0 L${width} ${height} L${triangleHeight} ${height}" +
            " L${triangleHeight} ${heightMinusDE} L0 ${heightDivideTwo} L${triangleHeight} ${ga} Z";
        return string.substitute(path, {
            triangleHeight: triangleHeight,
            height: size.height,
            width: size.width,
            heightMinusDE: size.height - de,
            heightDivideTwo: size.height / 2,
            ga: ga
        });
    }

    function hideTooltips() {
        var anchors = this._anchors;
        anchors.tooltips.select('text').text("");
        anchors.tooltips.style({display: 'none'});
    }



    var props = {
        _mode: undefined,
        _data: undefined,
        _dataset: undefined,
        _title: undefined,
        _marker: undefined,
        tagName: 'g'
    };

    var LineSeries = declare(Base, {
        initialize: initialize,
        render: render,
        marker: marker,
        title: title,
        data: data,
        xField: xField,
        yField: yField,
        xAxis: xAxis,
        yAxis: yAxis,
        mode: mode,
        trendline: trendline
    }, props);


    return LineSeries;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
